program SWFCmp;

uses
  SysUtils,
  Classes,
  Dialogs,
  zlib;

{$R *.res}

procedure DecompressStream(inpStream, outStream: TStream);
var
  InpBuf, OutBuf: Pointer;
  OutBytes, sz: Integer;
begin
  InpBuf := nil;
  OutBuf := nil;
  sz     := inpStream.Size - inpStream.Position;
  if sz > 0 then 
    try
      GetMem(InpBuf, sz);
      inpStream.Read(InpBuf^, sz);
      DecompressBuf(InpBuf, sz, 0, OutBuf, OutBytes);
      outStream.Write(OutBuf^, OutBytes);
    finally
      if InpBuf <> nil then FreeMem(InpBuf);
      if OutBuf <> nil then FreeMem(OutBuf);
    end;
  outStream.Position := 0;
end;

procedure CompressStream(inpStream, outStream: TStream);
var
  InpBuf, OutBuf: Pointer;
  InpBytes, OutBytes: Integer;
begin
  InpBuf := nil;
  OutBuf := nil;
  try
    GetMem(InpBuf, inpStream.Size);
    inpStream.Position := 0;
    InpBytes := inpStream.Read(InpBuf^, inpStream.Size);
    CompressBuf(InpBuf, InpBytes, OutBuf, OutBytes);
    outStream.Write(OutBuf^, OutBytes);
  finally
    if InpBuf <> nil then FreeMem(InpBuf);
    if OutBuf <> nil then FreeMem(OutBuf);
  end;
end;

var
  FileStream, FileStream2: TFileStream;
  ms: TMemoryStream;
  by: array[0..7] of char;
  opendialog1: topendialog;

begin
  opendialog1 := topendialog.Create(nil);
  try
    opendialog1.DefaultExt := '.swf';
    opendialog1.Filter := 'Shockwave Flash Files (*.swf)|*.swf|Alle Dateien (*.*)|*.*';
    opendialog1.Options := [ofHideReadOnly, ofPathMustExist, ofFileMustExist, ofEnableSizing];
    if opendialog1.Execute() then
    begin
      FileStream := TFileStream.Create(opendialog1.FileName, fmOpenReadWrite);
      try
        FileStream.Position := 0;
        FileStream.Read(by[0], 1);
        FileStream.Read(by[1], 1);
        FileStream.Read(by[2], 1);
        FileStream.Read(by[3], 1);
        FileStream.Read(by[4], 1);
        FileStream.Read(by[5], 1);
        FileStream.Read(by[6], 1);
        FileStream.Read(by[7], 1);
        if (by[1] = 'W') and (by[2] = 'S') then
        begin
          if by[0] = 'F' then
          begin
            // Kompression...
            FileStream.Position := 8;
            ms := TMemoryStream.Create;
            FileStream2 := TFileStream.Create(copy(opendialog1.FileName, 0, length(opendialog1.FileName)-length(ExtractFileExt(opendialog1.FileName)))+'_comp'+ExtractFileExt(opendialog1.FileName), fmCreate);
            try
              ms.CopyFrom(FileStream, FileStream.size-8);
              by[0] := 'C';
              FileStream2.Write(by[0], 1);
              FileStream2.Write(by[1], 1);
              FileStream2.Write(by[2], 1);
              FileStream2.Write(by[3], 1);
              FileStream2.Write(by[4], 1);
              FileStream2.Write(by[5], 1);
              FileStream2.Write(by[6], 1);
              FileStream2.Write(by[7], 1);
              ms.Position := 0;
              CompressStream(ms, FileStream2);
            finally
              ms.Free;
              FileStream2.free;
            end;
            showmessage('Die SWF-Datei "' + ExtractFileName(opendialog1.FileName) + '" wurde komprimiert zu "' + ExtractFileName(copy(opendialog1.FileName, 0, length(opendialog1.FileName)-length(ExtractFileExt(opendialog1.FileName)))+'_comp'+ExtractFileExt(opendialog1.FileName)) +'".');
          end
          else if by[0] = 'C' then
          begin
            // Dekompression...
            FileStream.Position := 8;
            ms := TMemoryStream.Create;
            FileStream2 := TFileStream.Create(copy(opendialog1.FileName, 0, length(opendialog1.FileName)-length(ExtractFileExt(opendialog1.FileName)))+'_decomp'+ExtractFileExt(opendialog1.FileName), fmCreate);
            try
              ms.CopyFrom(FileStream, FileStream.size-8);
              by[0] := 'F';
              FileStream2.Write(by[0], 1);
              FileStream2.Write(by[1], 1);
              FileStream2.Write(by[2], 1);
              FileStream2.Write(by[3], 1);
              FileStream2.Write(by[4], 1);
              FileStream2.Write(by[5], 1);
              FileStream2.Write(by[6], 1);
              FileStream2.Write(by[7], 1);
              ms.Position := 0;
              DeCompressStream(ms, FileStream2);
            finally
              ms.Free;
              FileStream2.free;
            end;
            showmessage('Die SWF-Datei "' + ExtractFileName(opendialog1.FileName) + '" wurde dekomprimiert zu "' + ExtractFileName(copy(opendialog1.FileName, 0, length(opendialog1.FileName)-length(ExtractFileExt(opendialog1.FileName)))+'_decomp'+ExtractFileExt(opendialog1.FileName)) +'".');
          end
          else
          begin
            showmessage('Keine gltige SWF-Datei!');
          end;
        end
        else
        begin
          showmessage('Keine gltige SWF-Datei!');
        end;
      finally
        FileStream.Free;
      end;
    end;
  finally
    opendialog1.Free;
  end;
end.
